import * as rx from 'rxjs';
import * as RxMe from 'rxme';
export declare const State: {
    OK: string;
    ERROR: string;
};
export declare class QEntryRun {
    started: Date;
    _completed: Date;
    _error: any;
    constructor();
    error(err: any): void;
    completed(): void;
}
export declare class QEntry<T> {
    created: Date;
    runs: QEntryRun[];
    input: RxMe.Observable<T>;
    output: RxMe.Subject<T>;
    constructor(input: RxMe.Observable<T>, output: RxMe.Subject<T>);
    isCompleted(): boolean;
    isWaiting(): boolean;
    newQEntryRun(): QEntryRun;
}
export interface QConfig {
    taskTimer?: number;
    reclaimTimeout?: number;
    retryWaitTime?: number;
    maxExecuteCnt?: number;
}
export interface QWorker<T> {
    (input: RxMe.Observable<T>, output: RxMe.Subject<T>): void;
}
export declare class WorkerState<T> {
    private running;
    private output;
    private readonly qWorker;
    private readonly q;
    constructor(q: Queue<T>, qw: QWorker<T>);
    isFree(): boolean;
    run(qe: QEntry<any>): void;
}
export declare class Subject<T> extends RxMe.Subject<Queue<T>> {
    constructor(a: any);
}
export interface Observer<T> extends RxMe.Observer<Queue<T>> {
}
export declare class Observable<T> extends RxMe.Observable<Queue<T>> {
}
export declare class Logger<T> {
    private readonly upStream;
    private readonly base;
    constructor(upStream: Subject<T>, qid: number);
    info(...args: any[]): void;
    error(...args: any[]): void;
    debug(...args: any[]): void;
}
export declare class Queue<T> {
    qEntries: QEntry<any>[];
    qTask: number;
    reclaimTimeout: number;
    taskTimer: number;
    retryWaitTime: number;
    maxExecuteCnt: number;
    readonly workers: WorkerState<T>[];
    private readonly lengthSubject;
    readonly logger: Logger<T>;
    constructor(obs: Subject<T>, argv: QConfig, id: number);
    addWorker(qw: QWorker<T>): Queue<T>;
    length(): rx.Subject<number>;
    stop(): RxMe.Observable<void>;
    processMemoryQ(): void;
    push<Y>(action: RxMe.Observable<Y>, completed: RxMe.Subject<Y>): void;
}
export declare function start<T>(argv: QConfig): Observable<T>;
export default Queue;
